#include <iostream>
#include <fstream>
#include <sstream>
#include <memory>
#include <string>

#include <grpcpp/grpcpp.h>
#include "turbo.grpc.pb.h"


using namespace grpc;
using namespace Turbo;
using namespace std;

// Logic and data behind the server's behavior.
class GreeterServiceImpl final : public Greeter::Service 
{
	Status Ping(ServerContext *context, const TurboRequest_t *request, TurboReply_t *reply) override 
	{
		cout << "Server received file " << request->orig_file_name() << ": " << endl;
		cout << request->orig_contents().substr(0,10) << endl;

		ofstream fout("client.ls", ios::binary);
		fout << request->orig_contents();

		const auto send_filename = string("/bin/cat");
		ifstream fin(send_filename, ios::binary);
		ostringstream ostrm;
		ostrm << fin.rdbuf();
		const auto send_contents = ostrm.str();

		cout << "Server sending file " << send_filename << ": " << endl;
		cout << send_contents.substr(0,10) << endl;

		reply->set_zafl_file_name(send_filename);
		reply->set_zafl_contents(send_contents);
		return Status::OK;
	}
};

void RunServer() 
{
	const auto server_address=string("0.0.0.0:50051");
	GreeterServiceImpl service;

	ServerBuilder builder;
	// Listen on the given address without any authentication mechanism.
	builder.AddListeningPort(server_address, grpc::InsecureServerCredentials());

	// Register "service" as the instance through which we'll communicate with
	// clients. In this case it corresponds to an *synchronous* service.
	builder.RegisterService(&service);

	// Finally assemble the server.
	unique_ptr<Server> server(builder.BuildAndStart());
	cout << "Server listening on " << server_address << endl;

	// Wait for the server to shutdown. Note that some other thread must be
	// responsible for shutting down the server for this call to ever return.
	server->Wait();
}

int main(int argc, char **argv) 
{
  RunServer();
  return 0;
}
